=begin
=cut

use Time::HiRes qw(usleep);
#use strict;

#conntrack_down(10, 'tcp 10.22.0.104 10.22.0.100 10.22.0.104 10.22.0.100 22 38479 1');
#conntrack_down(10, 'tcp 10.22.0.100 10.22.0.104 10.22.0.100 10.22.0.104 38479 22 1');

sub conntrack_down {
    my $command=shift;
    my $input=shift;
    my ($proto, $pip_src_ip, $pip_dst_ip, $eip_src_ip, $eip_dst_ip, $src_port, $dst_port, $time_to_exec) = split(" ",$input);
    my $right = 1; #right-hand side holds pip will be 0 if left-hand side holds pip

    print "Received: proto, pip_src_ip, pip_dst_ip, eip_src_ip, eip_dst_ip, src_port, dst_port, time_to_exec\n";
    print "Received: $proto, $pip_src_ip, $pip_dst_ip, $eip_src_ip, $eip_dst_ip, $src_port, $dst_port, $time_to_exec\n";


	my $output = `sudo conntrack -L | grep $pip_dst_ip`;
	chomp($output);
	print "OUTPUT = " . $output . "\n";
	if($output=~m/$proto.*sport=$dst_port.*dport=$src_port.*src=$pip_src_ip.*dst=$pip_dst_ip.*/){ # if correct on right, backwards on left. don't know which port is random so need both
		print "1. On right hand side in correct order\n";
	} 
	else{
		# check right-hand side for pips
		if($output=~m/$proto.*sport=$src_port.*dport=$dst_port.*src=$pip_dst_ip.*dst=$pip_src_ip.*/){
			print "2. On right hand side in wrong order. SWAPPING\n";
			#swap ip
			my $temp = $pip_src_ip;
			$pip_src_ip = $pip_dst_ip;
			$pip_dst_ip = $temp;

			#swap port
			$temp = $src_port;
			$src_port = $dst_port;
			$dst_port = $temp;
		}
		# check left-hand side for pips
		elsif($output=~m/$proto.*src=$pip_src_ip.*dst=$pip_dst_pip.*sport=$src_port.*dport=$dst_port.*/){
			print "3. Stuff's on the LEFT in correct order... setting right=0\n";
			$right=0; # oh-no! pips on left but are in right order!
		}
		else{
			print "4. Stuff's on the LEFT in wrong order. Swapping and setting right=0\n";
			$right=0; # oh-no! pips on left but are in wrong order!
			# now reverse them!
			my $temp = $pip_src_ip;
			$pip_src_ip = $pip_dst_ip;
			$pip_dst_ip = $temp;

			#swap port
			$temp = $src_port;
			$src_port = $dst_port;
			$dst_port = $temp;
		}
	}


#errorCheck($proto, $pip_src_ip, $pip_dst_ip, $eip_src_ip, $eip_dst_ip, $src_port, $dst_port);
	print "After swap: $proto, $pip_src_ip, $pip_dst_ip, $eip_src_ip, $eip_dst_ip, $src_port, $dst_port, $time_to_exec\n";

	my $WAIT = 0;
	if($WAIT){
		while(time() < $time_to_exec){
			usleep(100); # 100 microseconds or .1 milliseconds
		}
	}


	#if($proto eq "tcp"){
	#	my $ret=`sudo conntrack -D -s $pip_src_ip -d $pip_dst_ip -q $eip_src_ip -r $eip_dst_ip -p $proto --dport $dst_port --sport $src_port --reply-port-src $dst_port --reply-port-dst $src_port`;
	#	print "sudo conntrack -D -s $pip_src_ip -d $pip_dst_ip -q $eip_src_ip -r $eip_dst_ip -p $proto --dport $dst_port --sport $src_port --reply-port-src $dst_port --reply-port-dst $src_port\n";
	#}
	#else{
		if($right==1){
			my $ret=`sudo conntrack -D -r $pip_src_ip -q $pip_dst_ip -p $proto --reply-port-src $src_port --reply-port-dst $dst_port`;
			print "RIGHT SIDE: sudo conntrack -D -r $pip_src_ip -q $pip_dst_ip -p $proto --reply-port-src $src_port --reply-port-dst $dst_port\n";
		} else{
			my $ret=`sudo conntrack -D -s $pip_src_ip -d $pip_dst_ip -p $proto --sport $src_port --dport $dst_port`;
			print "LEFT SIDE: sudo conntrack -D -s $pip_src_ip -d $pip_dst_ip -p $proto --sport $src_port --dport $dst_port\n";
		}
	#}
# Am not sure of how to check $ret to see if it passed. Can probably regex for "entries deleted {1-9}{0-9}*"
	return 0;
}

1;

=begin
		if($output=~m/$proto.*src=$pip_src_ip.*dst=$pip_dst_pip.*sport=$src_port.*dport=$dst_port.*src=$eip_dst_ip.*dst=$eip_src_ip.*sport=$dst_port.*dport=$src_port/){
# things match exact, do nothing
		} 
# switch pips and eips, just leave ports
	elsif($output=~m/$proto.*src=$eip_src_ip.*dst=$eip_dst_pip.*sport=$src_port.*dport=$dst_port.*src=$pip_dst_ip.*dst=$pip_src_ip.*sport=$dst_port.*dport=$src_port/){
#switch pip/eip src
		my $temp = $pip_src_ip;
		$pip_src_ip = $eip_src_ip;
		$eip_src_ip = $temp;

#switch pip/eip dst
		$temp = $pip_dst_ip;
		$pip_dst_ip = $eip_dst_ip;
		$eip_dst_ip = $temp;
	}
# flip pips and flip eips, also flip ports
	elsif($output=~m/$proto.*src=$pip_dst_ip.*dst=$pip_src_pip.*sport=$dst_port.*dport=$src_port.*src=$eip_src_ip.*dst=$eip_dst_ip.*sport=$src_port.*dport=$dst_port/){

#flip pips
		my $temp = $pip_src_ip;
		$pip_src_ip = $pip_dst_ip;
		$pip_dst_ip = $temp;

#flip eips
		$temp = $eip_src_ip;
		$eip_src_ip = $eip_dst_ip;
		$eip_dst_ip = $temp;

#flip ports
		$temp = $src_port;
		$src_port = $dst_port;
		$dst_port = $temp;
	}
# switch pips and eips, flip pips and eips, flip ports
	elsif($output=~m/$proto.*src=$eip_dst_ip.*dst=$eip_src_pip.*sport=$dst_port.*dport=$src_port.*src=$pip_src_ip.*dst=$pip_dst_ip.*sport=$src_port.*dport=$dst_port/){
#flip pips
		my $temp = $pip_src_ip;
		$pip_src_ip = $pip_dst_ip;
		$pip_dst_ip = $temp;

#flip eips
		$temp = $eip_src_ip;
		$eip_src_ip = $eip_dst_ip;
		$eip_dst_ip = $temp;

#swap pip src, eip src
		$temp = $pip_src_ip;
		$pip_src_ip = $eip_src_ip;
		$eip_src_ip = $temp;

#swap pip dst, eip dst
		$temp = $pip_dst_ip;
		$pip_dst_ip = $eip_dst_ip;
		$eip_dst_ip = $temp;

#swap ports
		$temp = $src_port;
		$src_port = $dst_port;
		$dst_port = $temp;
	}
=cut


