#!/usr/bin/perl

use strict;

open my $FIN2, ">>/home/crtaylor/start_up_ran.txt" or die $!;
print $FIN2 "Start up script executed at " . time() . "\n";
close($FIN2);

#my $hostnameFile = "/etc/hostname";
my $hostnameFile = "/etc/hostname";
my $thanks = `modprobe ip_conntrack`;
$thanks = `ntpdate 10.22.2.2`;
$thanks = system("(sleep 10 && sudo ntpdate 10.22.2.2) &");
$thanks = system("(sleep 2 && sudo sh /home/crtaylor/cs558_choreo_pan/code/scripts/disable) &");
# Should be in iptables_up now. Need to call tcp_rst_drop.pm though
#$thanks = `iptables -A OUTPUT -p tcp --tcp-flags RST RST -j DROP`;

my $hostname = `cat $hostnameFile`;
chomp($hostname);
if($hostname eq ""){
	print "ERROR: no hostname\n";
	exit(1);
}

my $basename = "master";

if($hostname eq $basename){

	my $cmd = "/sbin/ifconfig eth0 |grep \"Link encap\" | awk '{print \$5;}'";
	#my $cmd = "/sbin/ifconfig en1 |grep \"ether\" | awk '{print \$2;}'";
	my $mac = `$cmd`;
	chomp($mac);
	if($mac eq "52:54:00:9d:55:5f"){
		open my $FIN, ">/home/crtaylor/client_boot_log.txt" or die $!;
		print $FIN "MASTER IMAGE: Did not change hostname at " . time() . "\n";
		close($FIN);
		exit(1);
	}
	elsif($mac eq ""){
		print "ERROR: No eth0 mac\n";
		exit(1);
	}

	my $new_hostname = hostnameLookUp($mac);
	if($new_hostname eq ""){
		print "ERROR: no hostname in hash\n";
		exit(1);
	}
	fixHostname($new_hostname);
	fixHostsFile($new_hostname);
	exit(1);

} else{
	open my $FIN, ">/home/crtaylor/client_boot_log.txt" or die $!;
	print $FIN "Did not change hostname at " . time() . "\n";
	close($FIN);
}

my $start_agent = system("(sleep 10 && cd /home/crtaylor/cs558_choreo_pan/code/all && sudo perl snmp-host-agent.pl > /home/crtaylor/client_snmp_host_log.txt 2>&1) &");
my $start_poller = system("(sleep 10 && cd /home/crtaylor/cs558_choreo_pan/code/all && sudo perl poller.pl) > /home/crtaylor/client_snmp_poller_log.txt 2>&1 &");

sub hostnameLookUp {

	my $mac = shift;
	my %macToHostname = {};

	$macToHostname{'52:54:00:52:af:1b'}="client1";
	$macToHostname{'52:54:00:aa:79:28'}="client2";
	$macToHostname{'52:54:00:52:af:1c'}="client3";
	$macToHostname{'52:54:00:52:af:1d'}="client4";
	$macToHostname{'52:54:00:52:af:1e'}="client5";
	$macToHostname{'52:54:00:52:af:1f'}="client6";
	$macToHostname{'52:54:00:52:af:20'}="client7";
	$macToHostname{'52:54:00:52:af:21'}="client8";
	$macToHostname{'52:54:00:52:af:22'}="client9";
	$macToHostname{'52:54:00:52:af:23'}="client10";
	$macToHostname{'52:54:00:52:af:24'}="client11";
	$macToHostname{'52:54:00:52:af:25'}="client12";
	$macToHostname{'52:54:00:52:af:26'}="client13";
	$macToHostname{'52:54:00:52:af:27'}="client14";
	$macToHostname{'52:54:00:52:af:28'}="client15";
	$macToHostname{'52:54:00:52:af:29'}="client16";
	$macToHostname{'52:54:00:52:af:2a'}="client17";
	$macToHostname{'52:54:00:52:af:2b'}="client18";
	$macToHostname{'52:54:00:52:af:2c'}="client19";
	$macToHostname{'52:54:00:52:af:2e'}="client20";

	return $macToHostname{$mac};

}

sub fixHostname {
	my $name = shift;

	my $hostnameFile = "/etc/hostname";
	my $cmd = "echo $name > $hostnameFile";
	my $ret = `$cmd`;
}

sub fixHostsFile {
	my $name = shift;
	
	my $hostsFile = "/etc/hosts";
	my $hostsFile_tmp = "/etc/hosts_tmp";

	open my $FIN, "< $hostsFile" or die $!;
	open my $FOUT, "> $hostsFile_tmp" or die $!;

	while(my $line = <$FIN>){
		chomp($line);
		if($line =~ m/(127.0.1.1\t)(.*)/){
			print $FOUT $1 . $name . "\n";
		} else{
			print $FOUT $line . "\n";
		}
	}
	close($hostsFile);
	close($hostsFile_tmp);

	my $ret = `mv $hostsFile_tmp $hostsFile`;
	$ret = `reboot`;
	exit(1);
}
