=begin
use strict;
my $pip="10.22.0.3";
my $eip="10.22.0.99";
iptables_up("15",$pip,$eip);
=cut

sub iptables_up {
    my $command=shift;
    my $input=shift;
    my ($proto, $pip_src_ip, $pip_dst_ip, $eip_src_ip, $eip_dst_ip, $src_port, $dst_port) = split(" ",$input);

    my $ret=`sudo iptables -t nat -A PREROUTING -i eth0 -p $proto --src $eip_dst_ip --dest $eip_src_ip --sport $dst_port --dport $src_port -j DNAT --to-destination $pip_src_ip`;
    $ret=`sudo iptables -t nat -A INPUT -i eth0 -p $proto --src $eip_dst_ip --dest $pip_src_ip --sport $dst_port --dport $src_port -j SNAT --to $pip_dst_ip`;
    $ret=`sudo iptables -t nat -A OUTPUT -o eth0 -p $proto --src $pip_src_ip --dest $pip_dst_ip --sport $src_port --dport $dst_port -j DNAT --to-destination $eip_dst_ip`;
    $ret=`sudo iptables -t nat -A POSTROUTING -o eth0 -p $proto --src $pip_src_ip --dest $eip_dst_ip --sport $src_port --dport $dst_port -j SNAT --to $eip_src_ip`;
    $ret=`iptables -A OUTPUT -p tcp --tcp-flags RST RST -j DROP`;
    $ret=`iptables -A OUTPUT -p icmp --icmp-type 3 -j DROP`;
    return 0;
}

1;
