#!/usr/bin/perl

use strict;
use warnings;

use Net::SNMP;
#use NetSNMP::ASN (':all');

my $OID = '.1.3.6.1.4.1.7128.9999.9999.2';

die "Need at least one parameter!\n" unless scalar(@ARGV);

#my $type  = shift;
#my ($proto, $src_pip, $dst_pip, $src_port, $dst_port) = split(/\s+/, shift);
# sudo perl snmp-manager-sender.pl 13 tcp 10.22.0.100 10.22.0.104 ?? 22

my @new_arg;
push(@new_arg, $ARGV[0]);
my $time = time();
push(@new_arg, $time);

my $arg_num = 2;
while(($arg_num -1) < @ARGV){
	my $index = $arg_num - 1;
	push(@new_arg, $ARGV[$index]);
	$arg_num+=1;
}

my $input = join(' ', @new_arg);

my ($hostname) = ('10.22.2.3');

my $username = 'controller';
my $password = 'password';

my ($session, $error) = Net::SNMP->session(
                           -hostname      => $hostname,
                           -version       => '3',
                           -username      => $username,  # v3
                           -authpassword  => $password,  # v3
                           -authprotocol  => 'sha',      # v3
                           -privpassword  => $password,  # v3
                           -privprotocol  => 'aes',      # v3
                        );

if (!defined $session) {
    printf "ERROR: %s.\n", $error;
    exit(1);
}

my $result = $session->set_request(
                          -varbindlist => [ $OID, OCTET_STRING, $input ],
                       );

unless(defined $result) {
    warn $session->error();
    exit(1);
}

$session->close();

exit(0);
